



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Hibernate第六篇【多对多映射、一对一映射】</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Hibernate第六篇【多对多映射、一对一映射】</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-12 02:09:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<h1>前言</h1>
<p>前面已经讲解了一对多和多对一的映射是怎么配置了，也讲解了inverse和cascade属性对关联关系的影响，<strong>本博文讲解多对多的映射和一对一的映射！</strong></p>
<h1>多对多映射</h1>
<p>需求：<strong>一个项目由多个员工开发，一个员工开发多个项目</strong></p>
<h2>设计数据库表</h2>
<p>一般地，<strong>如果是多对多的映射，我们都会使用一张中间表来保存它们的关联关系</strong>….</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20170507135440970?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvaG9uXzN5/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast"></p>
<h2>设计实体</h2>
<p>我们在设计实体的时候，一般是<strong>核心数据表对应一个JavaBean实体【中间表并不是核心数据表】</strong>，那么我们将会设计两个JavaBean对象</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20170507135605092?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvaG9uXzN5/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast"></p>
<p><strong>project.java</strong></p>
<pre class="prettyprint linenums"><code><br />
package zhongfucheng.many2many;

import java.util.HashSet;<br />
import java.util.Set;

/**<br />
 * Created by ozc on 2017/5/7.<br />
 */

public class Project {

    private int projectId;<br />
    private String projectName;

    //使用Set集合与developer实体维护关系<br />
    private Set&lt;Developer&gt; developers = new HashSet&lt;&gt;();

    public int getProjectId() {<br />
        return projectId;<br />
    }

    public void setProjectId(int projectId) {<br />
        this.projectId = projectId;<br />
    }

    public String getProjectName() {<br />
        return projectName;<br />
    }

    public void setProjectName(String projectName) {<br />
        this.projectName = projectName;<br />
    }

    public Set&lt;Developer&gt; getDevelopers() {<br />
        return developers;<br />
    }

    public void setDevelopers(Set&lt;Developer&gt; developers) {<br />
        this.developers = developers;<br />
    }<br />
}<br />
</code></pre>
<p><strong>developer.java</strong></p>
<pre class="prettyprint linenums"><code>

package zhongfucheng.many2many;

import java.util.HashSet;<br />
import java.util.Set;

/**<br />
 * Created by ozc on 2017/5/7.<br />
 */<br />
public class Developer {

    private int developerId;<br />
    private String developerName;

    //使用Set集合来维护与Project关系<br />
    private Set&lt;Project&gt; projects = new HashSet&lt;&gt;();

    public int getDeveloperId() {<br />
        return developerId;<br />
    }

    public void setDeveloperId(int developerId) {<br />
        this.developerId = developerId;<br />
    }

    public String getDeveloperName() {<br />
        return developerName;<br />
    }

    public void setDeveloperName(String developerName) {<br />
        this.developerName = developerName;<br />
    }

    public Set&lt;Project&gt; getProjects() {<br />
        return projects;<br />
    }

    public void setProjects(Set&lt;Project&gt; projects) {<br />
        this.projects = projects;<br />
    }<br />
}<br />
</code></pre>
<h2>映射配置文件</h2>
<p><strong>以项目映射文件为例：</strong>我们不急着写，首先来<strong>分析一下关键点</strong>……想要在多对多映射中产生正确的关联关系，下面几步必不可少：</p>
<ul><li><strong>配置映射集合的属性(developers)</strong></li>
<li><strong>映射集合对应的中间表(developer_project)</strong></li>
<li><strong>中间表的外键字段(project_id)</strong></li>
<li><strong>集合元素的类型(Developer)</strong></li>
<li><strong>中间表另外的外键字段(developer_id)</strong></li></ul>
<p><strong>Project和Developer的映射文件都需要这几个关键步骤</strong></p>
<h3><strong>Project映射文件</strong></h3>
<pre class="prettyprint linenums"><code>&lt;?xml version="1.0"?&gt;<br />
&lt;!DOCTYPE hibernate-mapping PUBLIC<br />
        "-//Hibernate/Hibernate Mapping DTD 3.0//EN"<br />
        "http://www.hibernate.org/dtd/hibernate-mapping-3.0.dtd"&gt;

&lt;!--在domain包下--&gt;<br />
&lt;hibernate-mapping package="zhongfucheng.many2many"&gt;

    &lt;class name="Project" table="Project"&gt;

        &lt;!--映射主键--&gt;<br />
        &lt;id name="projectId" column="projectId"&gt;<br />
            &lt;generator class="native"&gt;&lt;/generator&gt;<br />
        &lt;/id&gt;

        &lt;!--映射普通字段--&gt;<br />
        &lt;property name="projectName" column="projectName"&gt;&lt;/property&gt;

        &lt;!--映射多对多的关系--&gt;<br />
        &lt;!--Set的属性名称为developers，对应developer_project表--&gt;<br />
        &lt;set name="developers" table="developer_project"&gt;<br />
            &lt;!--对应developer_project表的外键列--&gt;<br />
            &lt;key column="project_id"&gt;&lt;/key&gt;

            &lt;!--集合的类型和developer_project表的另一个外键列--&gt;<br />
            &lt;many-to-many column="developer_id" class="Developer"&gt;&lt;/many-to-many&gt;<br />
        &lt;/set&gt;

    &lt;/class&gt;

&lt;/hibernate-mapping&gt;

</code></pre>
<hr>
<h3><strong>Developer映射文件</strong></h3>
<pre class="prettyprint linenums"><code><br />
&lt;?xml version="1.0"?&gt;<br />
&lt;!DOCTYPE hibernate-mapping PUBLIC<br />
        "-//Hibernate/Hibernate Mapping DTD 3.0//EN"<br />
        "http://www.hibernate.org/dtd/hibernate-mapping-3.0.dtd"&gt;

&lt;!--在domain包下--&gt;<br />
&lt;hibernate-mapping package="zhongfucheng.many2many"&gt;

    &lt;class name="Developer" table="Developer"&gt;

        &lt;!--映射主键--&gt;<br />
        &lt;id name="developerId" column="developerId"&gt;<br />
            &lt;generator class="native"&gt;&lt;/generator&gt;<br />
        &lt;/id&gt;

        &lt;!--映射普通字段--&gt;<br />
        &lt;property name="developerName" column="developerName"&gt;&lt;/property&gt;

        &lt;!--映射多对多的关系--&gt;<br />
        &lt;!--Set的属性名称为developers，对应developer_project表--&gt;<br />
        &lt;set name="projects" table="developer_project"&gt;<br />
            &lt;!--对应developer_project表的外键列--&gt;<br />
            &lt;key column="developer_id"&gt;&lt;/key&gt;

            &lt;!--集合的类型和developer_project表的另一个外键列--&gt;<br />
            &lt;many-to-many column="project_id" class="Project"&gt;&lt;/many-to-many&gt;<br />
        &lt;/set&gt;

    &lt;/class&gt;

&lt;/hibernate-mapping&gt;<br />
</code></pre>
<hr>
<h2>测试</h2>
<pre class="prettyprint linenums"><code><br />
package zhongfucheng.many2many;

import org.hibernate.SessionFactory;<br />
import org.hibernate.Transaction;<br />
import org.hibernate.cfg.Configuration;<br />
import org.hibernate.classic.Session;

/**<br />
 * Created by ozc on 2017/5/6.<br />
 */<br />
public class App2 {<br />
    public static void main(String[] args) {

        /*<br />
        *<br />
        *<br />
        *     Project   Developer<br />
              电商系统<br />
                             曹吉<br />
                             王春<br />
               OA系统<br />
                             王春<br />
                             老张

            */<br />
        //创建对象<br />
        Developer cj = new Developer();<br />
        Developer wc = new Developer();<br />
        Developer lz = new Developer();<br />
        Project ds = new Project();<br />
        Project oa = new Project();

        //设置对象的数据<br />
        cj.setDeveloperName("曹吉");<br />
        wc.setDeveloperName("王春");<br />
        lz.setDeveloperName("老张");

        oa.setProjectName("OA系统");<br />
        ds.setProjectName("电商系统");

        //使用Project来关联数据【在多对多中，一样的】<br />
        oa.getDevelopers().add(wc);<br />
        oa.getDevelopers().add(lz);

        ds.getDevelopers().add(cj);<br />
        ds.getDevelopers().add(wc);

        //获取加载配置管理类<br />
        Configuration configuration = new Configuration();

        //加载User的映射文件！<br />
        configuration.configure().addClass(Developer.class).addClass(Project.class);

        //创建Session工厂对象<br />
        SessionFactory factory = configuration.buildSessionFactory();

        //得到Session对象<br />
        Session session = factory.openSession();

        //使用Hibernate操作数据库，都要开启事务,得到事务对象<br />
        Transaction transaction = session.getTransaction();

        //开启事务<br />
        transaction.begin();

        //在Project映射文件中设置级联保存了<br />
        session.save(oa);<br />
        session.save(ds);

        //提交事务<br />
        transaction.commit();

        //关闭Session<br />
        session.close();<br />
    }<br />
}</code></pre>
<p>执行了9条SQL语句，数据库中的记录也是正确的。</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20170507142744044?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvaG9uXzN5/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast"></p>
<hr>
<h1>一对一的映射</h1>
<p>需求：<strong>用户与身份证信息..一个用户对应一个身份证</strong></p>
<h2>数据库表设计</h2>
<p>对于数据库表设计我们有两种方式</p>
<ul><li>第一种：<strong>在身份证的数据表中设置一个外键来维护用户的关系，这个外键也应该是唯一的【一个用户对应一张身份证】</strong></li>
<li>第二种：<strong>在身份证的数据表中使用主键+外键的方式来维护用户的关系。</strong></li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20170507143348236?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvaG9uXzN5/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast"></p>
<h2>设计实体</h2>
<p><strong>idCard.java</strong></p>
<pre class="prettyprint linenums"><code>package zhongfucheng.one2one;

/**<br />
 * Created by ozc on 2017/5/7.<br />
 */<br />
public class IdCard {

    private int idCardId;<br />
    private String idCardName;

    //维护与用户之间的关系<br />
    private User user ;

    public int getIdCardId() {<br />
        return idCardId;<br />
    }

    public void setIdCardId(int idCardId) {<br />
        this.idCardId = idCardId;<br />
    }

    public String getIdCardName() {<br />
        return idCardName;<br />
    }

    public void setIdCardName(String idCardName) {<br />
        this.idCardName = idCardName;<br />
    }

    public User getUser() {<br />
        return user;<br />
    }

    public void setUser(User user) {<br />
        this.user = user;<br />
    }<br />
}<br />
</code></pre>
<p><strong>User.java</strong></p>
<pre class="prettyprint linenums"><code>package zhongfucheng.one2one;

/**<br />
 * Created by ozc on 2017/5/7.<br />
 */<br />
public class User {

    private int userId;<br />
    private String userName;

    //维护与身份证一对一的关系<br />
    private IdCard idCard ;

    public int getUserId() {<br />
        return userId;<br />
    }

    public void setUserId(int userId) {<br />
        this.userId = userId;<br />
    }

    public String getUserName() {<br />
        return userName;<br />
    }

    public void setUserName(String userName) {<br />
        this.userName = userName;<br />
    }

    public IdCard getIdCard() {<br />
        return idCard;<br />
    }

    public void setIdCard(IdCard idCard) {<br />
        this.idCard = idCard;<br />
    }<br />
}<br />
</code></pre>
<hr>
<h2>第一种方式映射文件</h2>
<p>我们有两种方式来设计数据库中的表实现一对一的关系，首先我们来挑比较熟悉的外键方式来写映射文件</p>
<h3><strong>user映射文件</strong></h3>
<pre class="prettyprint linenums"><code><br />
&lt;?xml version="1.0"?&gt;<br />
&lt;!DOCTYPE hibernate-mapping PUBLIC<br />
        "-//Hibernate/Hibernate Mapping DTD 3.0//EN"<br />
        "http://www.hibernate.org/dtd/hibernate-mapping-3.0.dtd"&gt;

&lt;hibernate-mapping package="zhongfucheng.one2one"&gt;

    &lt;class name="User" table="User"&gt;

        &lt;!--映射主键--&gt;<br />
        &lt;id name="userId" column="userId"&gt;<br />
            &lt;generator class="native"&gt;&lt;/generator&gt;<br />
        &lt;/id&gt;

        &lt;!--映射普通字段--&gt;<br />
        &lt;property name="userName" column="userName"&gt;&lt;/property&gt;

        &lt;!--<br />
            User是没有外键字段的表<br />
                一对一的关系的属性名称name是idCard<br />
                类型是IdCard<br />
        --&gt;<br />
        &lt;one-to-one name="idCard" class="IdCard"&gt;&lt;/one-to-one&gt;

    &lt;/class&gt;

&lt;/hibernate-mapping&gt;<br />
</code></pre>
<h3><strong>idCard映射文件</strong></h3>
<pre class="prettyprint linenums"><code><br />
&lt;?xml version="1.0"?&gt;<br />
&lt;!DOCTYPE hibernate-mapping PUBLIC<br />
        "-//Hibernate/Hibernate Mapping DTD 3.0//EN"<br />
        "http://www.hibernate.org/dtd/hibernate-mapping-3.0.dtd"&gt;

&lt;hibernate-mapping package="zhongfucheng.one2one"&gt;

    &lt;class name="IdCard" table="IdCard"&gt;

        &lt;!--映射主键--&gt;<br />
        &lt;id name="idCardId" column="idCardId"&gt;<br />
            &lt;generator class="native"&gt;&lt;/generator&gt;<br />
        &lt;/id&gt;

        &lt;!--映射普通字段--&gt;<br />
        &lt;property name="idCardName" column="idCardName"&gt;&lt;/property&gt;

        &lt;!--idCart是有外键的表，要把字段映射成外键，用的是manyToOne--&gt;

        &lt;!--<br />
            外键的属性name是user<br />
            对应表的字段是userId<br />
            属性的类型是User<br />
            该字段需要唯一性 unique<br />
        --&gt;<br />
        &lt;many-to-one name="user" column="user_id" class="User" unique="true" cascade="save-update"&gt;&lt;/many-to-one&gt;

    &lt;/class&gt;

&lt;/hibernate-mapping&gt;<br />
</code></pre>
<h2>测试</h2>
<p><strong>要使用IdCart来维护User的关联关系。</strong></p>
<ul><li><strong>如果使用User来维护idCart的关联关系，idCart的外键列是为NULL的，因为重头到尾我们都没有给它赋值</strong></li>
<li><strong>而使用IdCart来维护User，是外键值是根据User的主键id来生成的</strong></li></ul>
<pre class="prettyprint linenums"><code>

package zhongfucheng.one2one;

import org.hibernate.SessionFactory;<br />
import org.hibernate.Transaction;<br />
import org.hibernate.cfg.Configuration;<br />
import org.hibernate.classic.Session;

/**<br />
 * Created by ozc on 2017/5/6.<br />
 */<br />
public class App3 {<br />
    public static void main(String[] args) {

        //创建对象<br />
        User user = new User();<br />
        IdCard idCard = new IdCard();

        //设置对象的数据<br />
        user.setUserName("你好");<br />
        idCard.setIdCardName("身份证001");

        //一对一关联数据<br />
        idCard.setUser(user);

        //获取加载配置管理类<br />
        Configuration configuration = new Configuration();

        //加载User的映射文件！<br />
        configuration.configure().addClass(User.class).addClass(IdCard.class);

        //创建Session工厂对象<br />
        SessionFactory factory = configuration.buildSessionFactory();

        //得到Session对象<br />
        Session session = factory.openSession();

        //使用Hibernate操作数据库，都要开启事务,得到事务对象<br />
        Transaction transaction = session.getTransaction();

        //开启事务<br />
        transaction.begin();

        //保存对象的数据,idCard配置文件使用级联保存<br />
        session.save(idCard);

        //提交事务<br />
        transaction.commit();

        //关闭Session<br />
        session.close();<br />
    }<br />
}</code></pre>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20170507151043707?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvaG9uXzN5/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast"></p>
<hr>
<h2>第二种方式映射文件</h2>
<p><strong>因为IdCart使用userId作为了主键，因此需要在JavaBean中配置多一个属性UserId…其他的都不用变</strong></p>
<pre class="prettyprint linenums"><code><br />
    private int userId;<br />
    public int getUserId() {<br />
        return userId;<br />
    }

    public void setUserId(int userId) {<br />
        this.userId = userId;<br />
    }</code></pre>
<p>在Hibernate第三篇讲解配置的时候，在generator节点下还有一个属性没有讲解，也就是foreign属性…现在来填坑了..</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20170507144234428?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvaG9uXzN5/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast"></p>
<h3><strong>idCard映射文件</strong></h3>
<p>idCart的映射文件主要在于:<strong>将主键也映射成外键来使用，这就需要用到foreign属性值了</strong></p>
<p><strong>使用<code>&lt;one-to-one&gt;</code>标签来配置基于主键的映射</strong></p>
<pre class="prettyprint linenums"><code><br />
&lt;?xml version="1.0"?&gt;<br />
&lt;!DOCTYPE hibernate-mapping PUBLIC<br />
        "-//Hibernate/Hibernate Mapping DTD 3.0//EN"<br />
        "http://www.hibernate.org/dtd/hibernate-mapping-3.0.dtd"&gt;

&lt;hibernate-mapping package="zhongfucheng.one2one2.one2one"&gt;

    &lt;class name="IdCard" table="IdCard"&gt;

        &lt;!--映射主键--&gt;<br />
        &lt;id name="userId" column="userId"&gt;<br />
            &lt;!--<br />
                做主键的同时也做外键<br />
                外键的类型名称为user<br />
            --&gt;<br />
            &lt;generator class="foreign"&gt;<br />
                &lt;param name="property"&gt;user&lt;/param&gt;<br />
            &lt;/generator&gt;<br />
        &lt;/id&gt;

        &lt;!--映射普通字段--&gt;<br />
        &lt;property name="idCardName" column="idCardName"&gt;&lt;/property&gt;<br />
        &lt;property name="idCardId" column="idCartId"&gt;&lt;/property&gt;

        &lt;!--<br />
            有外键的一方：<br />
                基于主键映射，使用oneToOne<br />
                constrained="true"  指定在主键上添加外键约束<br />
        --&gt;<br />
        &lt;one-to-one name="user" class="User" constrained="true"&gt;&lt;/one-to-one&gt;

    &lt;/class&gt;

&lt;/hibernate-mapping&gt;<br />
</code></pre>
<h3><strong>user映射文件</strong></h3>
<pre class="prettyprint linenums"><code><br />
&lt;?xml version="1.0"?&gt;<br />
&lt;!DOCTYPE hibernate-mapping PUBLIC<br />
        "-//Hibernate/Hibernate Mapping DTD 3.0//EN"<br />
        "http://www.hibernate.org/dtd/hibernate-mapping-3.0.dtd"&gt;

&lt;hibernate-mapping package="zhongfucheng.one2one2.one2one"&gt;

    &lt;class name="User" table="User"&gt;

        &lt;!--映射主键--&gt;<br />
        &lt;id name="userId" column="userId"&gt;<br />
            &lt;generator class="native"&gt;&lt;/generator&gt;<br />
        &lt;/id&gt;

        &lt;!--映射普通字段--&gt;<br />
        &lt;property name="userName" column="userName"&gt;&lt;/property&gt;

        &lt;!--<br />
            User是没有外键字段的表<br />
            一对一的关系的属性名称name是idCard<br />
            类型是IdCard<br />
        --&gt;<br />
        &lt;one-to-one name="idCard" class="IdCard"&gt;&lt;/one-to-one&gt;

    &lt;/class&gt;

&lt;/hibernate-mapping&gt;<br />
</code></pre>
<h2>测试</h2>
<pre class="prettyprint linenums"><code><br />
package zhongfucheng.one2one2.one2one;

import org.hibernate.SessionFactory;<br />
import org.hibernate.Transaction;<br />
import org.hibernate.cfg.Configuration;<br />
import org.hibernate.classic.Session;

/**<br />
 * Created by ozc on 2017/5/6.<br />
 */<br />
public class App4 {<br />
    public static void main(String[] args) {

        //创建对象<br />
        User user = new User();<br />
        IdCard idCard = new IdCard();

        //设置对象的数据<br />
        user.setUserName("你好3");<br />
        idCard.setIdCardName("身份证003");<br />
        idCard.setIdCardId(4235);

        //一对一关联数据<br />
        idCard.setUser(user);

        //获取加载配置管理类<br />
        Configuration configuration = new Configuration();

        //加载User的映射文件！<br />
        configuration.configure().addClass(User.class).addClass(IdCard.class);

        //创建Session工厂对象<br />
        SessionFactory factory = configuration.buildSessionFactory();

        //得到Session对象<br />
        Session session = factory.openSession();

        //使用Hibernate操作数据库，都要开启事务,得到事务对象<br />
        Transaction transaction = session.getTransaction();

        //开启事务<br />
        transaction.begin();

        //保存对象的数据,idCard配置文件使用级联保存<br />
        session.save(idCard);

        //提交事务<br />
        transaction.commit();

        //关闭Session<br />
        session.close();<br />
    }<br />
}</code></pre>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20170507153516391?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvaG9uXzN5/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast"></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zrm41q.html">android dialog</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jgwvw9.html">OpenGL Tutorial</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g6y67q.html">dl  dt  dd定义</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96n134q.html">oracle分析函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9prkzdq.html">Bootstrap3&period;0入门学习系列规划&lbrack;持续更新&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zwmv38.html">php -- php读取sqlserver2005的数据实现分页查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k11z359.html">centos彻底删除文件夹、文件命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ykgejq.html">oracle数据库一些问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnrkmj8.html">Hyper-V Windows 8&period;1 &amp;amp&semi; Windows Server 2012 R2 Q&amp;amp&semi;A</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mno3w2q.html">05-C语言运算符</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdnlek9.html">pytesser图片文本识别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljnor09.html">&lpar;简单&rpar;  POJ  3984  迷宫问题，BFS。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpk4jxq.html">Trailing Zeroes &lpar;III&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzdjy08.html">Jquery仿京东分类导航层简单实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpxwzzq.html">浏览器抓包（post）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpwk3r9.html">Prometheus-配置解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvgz6l8.html">android -------- 混淆打包报错&lpar;warning - InnerClass annotations are missing corresponding EnclosingMember annotations&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwn4j09.html">Django的model操作中一些常用的小点</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw01od8.html">gulp &lpar; http&colon;&sol;&sol;markpop&period;github&period;io&sol;2014&sol;09&sol;17&sol;Gulp入门教程 &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlk0yr9.html">Android使用动态代理搭建网络模块框架</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kp2wy59.html">神经网络与深度学习笔记 Chapter 3&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/950d5068.html">Spring（二）之配置&period;md</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljwekx9.html">【Ubuntu 16】启动Eclipse Indigo报错 error code1 jdk没有配置好</a>
			</li>
						<li><a href="https://www.batexi.com/a/8meyne2q.html">Oracle 11g的安装详细过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy16dm2q.html">3&lowbar;初学sql注入</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj3k7pq.html">ASP&period;NET Core 2&period;0使用Cookie认证实现SSO单点登录</a>
			</li>
						<li><a href="https://www.batexi.com/a/8meyd56q.html">HTML的基本标签</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzveo48.html">Django1-10-5管理界面中文设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1jd4xq.html">keepalive集群工作原理及应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd7kpz9.html">java基础解析系列&lpar;五&rpar;---HashMap并发下的问题以及HashTable和CurrentHashMap的区别</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
